searchNodes=[{"doc":"Provides a structure for ordering operations that need to happen, and how to roll them back if they fail. There are examples of usage in test/example_test.exs .","ref":"Manifest.html","title":"Manifest","type":"module"},{"doc":"Adds a Manifest.Step to the :steps key of the manifest. True to Elixir/Erlang practices, it is prepended to the list. The list is reversed the work is actually performed. See Manifest.Step for more information on what a step is.","ref":"Manifest.html#add_step/5","title":"Manifest.add_step/5","type":"function"},{"doc":"Reports on the results of perform/1 . Returns an :ok tuple with the value of the :previous key which contains the results of all the steps if all steps succeeded. Otherwise it returns an :error tuple with the Manifest.Step.operation/0 , as it's second element, the results of that step's Manifest.Step.work/0 , and the value of the :previous field at the time of failure. (Which, since all other work is halted, means the summary of work done.) It works essentially the same as the return of Ecto.Repo.transaction/1 when given an Ecto.Multi .","ref":"Manifest.html#digest/1","title":"Manifest.digest/1","type":"function"},{"doc":"Check if any of the steps had an error.","ref":"Manifest.html#errored?/1","title":"Manifest.errored?/1","type":"function"},{"doc":"Initializes a new t:Manifest.t() . The manifest is not customizable, so no options can be given to this function.","ref":"Manifest.html#new/0","title":"Manifest.new/0","type":"function"},{"doc":"Performs the steps in the order given to the manifest. (Each new call of add_step/1 prepends a Manifest.Step.t/0 to the list, then the list is reversed before performing.) If a step's Manifest.Step.work/0 succeeds without returning :no_rollback in the tuple, the Manifest.Step.parser/0 finds the identifier, and a Manifest.Step.rollback/0 is defined the rollback will be added to the :rollbacks stack. If a step fails, the :halt? will activate and no further work will be performed. The :errored key will be set to the operation that triggered the failure. Whether or not the step fails, a key-value pair will be added to the :previous field. The Manifest.Step.operation/0 will be the key of that key-value pair. TL;DR: There's three paths a step can take: It returns {:ok, term} in which case it will add a rollback to the stack. It returns {:ok, :no_rollback, term} where no rollback will be added. It returns {:error, term} which will halt the Manifest and no further steps will be performed. You can then choose to roll it all back where it will pop the functions off the stack. See digest/1 as it provides an easier way of extracting pertinent information on what happened during this function.","ref":"Manifest.html#perform/1","title":"Manifest.perform/1","type":"function"},{"doc":"Rolls back each operation in case of failure. Each Manifest.Step.t/0 that ran previous to the point of failure, defines a Manifest.Step.rollback/0 in the manifest, and didn't receive a :no_rollback in tuple that the step's Manifest.Step.work/0 returned, will be rolled back in reverse from the order the steps were performed. If any of the rollbacks fail, it stops attempting to roll back and returns an :error tuple. The error tuple has the Manifest.Step.operation/0 where it failed as it's second element, the reason as the third, and a map containing the results of all the successful roll backs up to that point. You can also call rollback/1 on a completely successful Manifest.","ref":"Manifest.html#rollback/1","title":"Manifest.rollback/1","type":"function"},{"doc":"","ref":"Manifest.html#t:t/0","title":"Manifest.t/0","type":"type"},{"doc":"Defines a Record that contains the necessary information to perform a step. The :work key defines the primary function to be run during the step. It should do the actual API call, GenServer call, or DB query. The :rollback key defines how the operation should be rolled back in the case of errors. It recieves a single arguement used to identify the resource to be reverted. The :parser key determines some form of identifier that the rollback function will recieve as it's argument. Can be anything as long as the rollback can use it.","ref":"Manifest.Step.html","title":"Manifest.Step","type":"module"},{"doc":"","ref":"Manifest.Step.html#step/1","title":"Manifest.Step.step/1","type":"macro"},{"doc":"","ref":"Manifest.Step.html#step/2","title":"Manifest.Step.step/2","type":"macro"},{"doc":"","ref":"Manifest.Step.html#t:operation/0","title":"Manifest.Step.operation/0","type":"type"},{"doc":"","ref":"Manifest.Step.html#t:parser/0","title":"Manifest.Step.parser/0","type":"type"},{"doc":"","ref":"Manifest.Step.html#t:rollback/0","title":"Manifest.Step.rollback/0","type":"type"},{"doc":"","ref":"Manifest.Step.html#t:t/0","title":"Manifest.Step.t/0","type":"type"},{"doc":"","ref":"Manifest.Step.html#t:valid_returns/0","title":"Manifest.Step.valid_returns/0","type":"type"},{"doc":"","ref":"Manifest.Step.html#t:work/0","title":"Manifest.Step.work/0","type":"type"},{"doc":"","ref":"Manifest.Step.MalformedReturnError.html","title":"Manifest.Step.MalformedReturnError","type":"exception"},{"doc":"","ref":"Manifest.Step.NotAFunctionError.html","title":"Manifest.Step.NotAFunctionError","type":"exception"},{"doc":"","ref":"Manifest.Step.NotAnAtomError.html","title":"Manifest.Step.NotAnAtomError","type":"exception"}]